package com.ruoyi.ucp.service.impl;

import cn.hutool.core.date.DateTime;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.ruoyi.ucp.entity.MeterInfoDay;
import com.ruoyi.ucp.mapper.MeterInfoDayMapper;
import com.ruoyi.ucp.service.IMeterInfoDayService;
import com.ruoyi.ucp.util.DatePart;
import com.ruoyi.ucp.util.SqlUtil;
import org.springframework.stereotype.Service;

import java.util.Collection;
import java.util.Date;
import java.util.List;

/**
 * <p>
 *  服务实现类
 * </p>
 *
 * @author gfhd
 * @since 2024-12-19
 */
@Service
public class MeterInfoDayServiceImpl extends ServiceImpl<MeterInfoDayMapper, MeterInfoDay> implements IMeterInfoDayService {
    @Override
    public boolean saveOrUpdateBatch(Collection<MeterInfoDay> entityList) {
        return super.saveOrUpdateBatch(entityList);
    }

    public List<MeterInfoDay> getDatasByPartSelects(Date date, DatePart datePart, String selects, String groupIds) {
        DateTime[] beginEnd = SqlUtil.getBeginEnd(date, datePart);
        QueryWrapper<MeterInfoDay> wrapper = new QueryWrapper<>();
        wrapper.select(selects + groupIds).groupBy(groupIds).between("record_date", beginEnd[0], beginEnd[1]);
        return super.list(wrapper);
    }
}
